function [vaf,P,Q]=kmeans(P,Q,X,m,n,K,L,variance)
%This function performs the two-mode k-means algorithm

%initialize V, number of iterations
sumP=sum(P);
sumQ=sum(Q);
V=P'*X*Q./(sumP'*sumQ);
oldV=0;
numiter=0;
Xtranspose=X';
XQ=X*Q;
onesn1=ones(n,1);
onesm1=ones(m,1);
while any(abs(oldV(:)-V(:))>10^-12)
    %update oldV, number of iterations
    oldV=V;
    numiter=numiter+1;    
    %update P using formulas of Vichi
    SL=sumQ.^0.5;
    Xsl=XQ*diag(1./SL);
    Vsl=diag(SL)*V';
    d=zeros(n,K);
    Vsl=Vsl(:)';
    T=reshape(Vsl(onesn1,:),[n L K]);
    %d contains the summed squared distances plus a constant term
    %that can be different for each row of P
    for k=1:K
        d(:,k)=sum((Xsl-T(:,:,k)).^2,2);
    end
    P=zeros(n,K);
    [A,B]=min(d,[],2);
    for i=1:n
        P(i,B(i))=1;
    end
    %fill empty clusters in P
    sumP=sum(P);
    if any(sumP==0)
        tempsum=sumP==0;
        QV=Q*V';
        QV=QV(:)';
        T=reshape(QV(onesn1,:),[n m K]);
        for k=1:K
            d(:,k)=sum((X-T(:,:,k)).^2,2);
        end
        distance=sum(P.*d,2);
        for k=1:K
            if tempsum(k)
                Max=-1;
                for i=1:n
                    if distance(i)>Max && sum(sum(onesn1*P(i,:).*P))>1
                        maxindex=i;
                        Max=distance(i);
                    end
                end
                distance(maxindex)=0;
                P(maxindex,:)=0;
                P(maxindex,k)=1;
            end
        end
        sumP=sum(P);
    end    
    %update V
    XtransposeP=Xtranspose*P;
    V=XtransposeP'*Q./(sumP'*sumQ);    
    %update Q using formulas of Vichi
    SL=sumP.^0.5;
    Xsl=XtransposeP*diag(1./SL);
    Vsl=diag(SL)*V;
    d=zeros(m,L);
    Vsl=Vsl(:)';
    T=reshape(Vsl(onesm1,:),[m K L]);
    for l=1:L
        d(:,l)=sum((Xsl-T(:,:,l)).^2,2);
    end
    Q=zeros(m,L);
    [A,B]=min(d,[],2);
    for i=1:m
        Q(i,B(i))=1;
    end
    %fill empty clusters in Q
    sumQ=sum(Q);
    if any(sumQ==0)
        tempsum=sumQ==0;
        PV=P*V;
        PV=PV(:)';
        T=reshape(PV(onesm1,:),[m n L]);
        for l=1:L
            d(:,l)=sum((Xtranspose-T(:,:,l)).^2,2);
        end
        distance=sum(Q.*d,2);
        for l=1:L
            if tempsum(l)
                Max=-1;
                for j=1:m
                    if distance(j)>Max && sum(sum(onesm1*Q(j,:).*Q))>1
                        maxindex=j;
                        Max=distance(j);
                    end
                end
                distance(maxindex)=0;
                Q(maxindex,:)=0;
                Q(maxindex,l)=1;
            end
        end
        sumQ=sum(Q);
    end
    %update V
    XQ=X*Q;
    V=P'*XQ./(sumP'*sumQ);
end
vaf=1-sumsqr(X-P*V*Q')/variance;